package cn.com.taiji.cql.test;

import org.geotools.api.data.*;
import org.geotools.api.feature.simple.SimpleFeature;
import org.geotools.api.feature.simple.SimpleFeatureType;
import org.geotools.api.filter.Filter;
import org.geotools.data.jdbc.datasource.DBCPDataSourceFactory;
import org.geotools.data.jdbc.datasource.DataSourceFinder;
import org.geotools.data.mysql.MySQLDialectBasic;
import org.geotools.data.mysql.MySQLFilterToSQL;
import org.geotools.filter.text.cql2.CQL;
import org.geotools.filter.text.ecql.ECQL;
import org.geotools.jdbc.JDBCDataStore;
import org.geotools.jdbc.JDBCDataStoreFactory;

import javax.sql.DataSource;
import java.util.HashMap;
import java.util.Map;

public class EcqlTest2 {

    public static void main(String[] args) throws Exception{

        Map<String, Object> mapParams = new HashMap<String, Object>();

        mapParams.put(JDBCDataStoreFactory.DATABASE.key, "geo");
        mapParams.put(JDBCDataStoreFactory.DBTYPE.key, "mysql");

        mapParams.put(JDBCDataStoreFactory.HOST.key, "172.16.67.23");
        mapParams.put(JDBCDataStoreFactory.PORT.key, "7306");
        mapParams.put(JDBCDataStoreFactory.USER.key, "root");
        mapParams.put(JDBCDataStoreFactory.PASSWD.key, "Ucsp123#");

        DataStore dataStore = DataStoreFinder.getDataStore(mapParams);

        String strData = "name = 1";

        MySQLFilterToSQL filterToSql = (MySQLFilterToSQL) new MySQLDialectBasic((JDBCDataStore) dataStore).createFilterToSQL();

        filterToSql.setDatabaseSchema("geo_test");

        //声明Query查询对象
        Query query = new Query("geo_test", CQL.toFilter(strData));

        FeatureReader<SimpleFeatureType, SimpleFeature> reader = dataStore.getFeatureReader(query, Transaction.AUTO_COMMIT);

        if(reader.hasNext()){
            SimpleFeature feature = reader.next();
            String locationWKT = feature.getAttribute("geometry_1").toString();
            System.out.println(locationWKT);
        } else{
            System.out.println("No data");
        }



        System.out.println("111111111111");




    }


    private void test1() throws Exception{

        //先定义cql查询语句
        String bbox = "bbox (geom, 115.31412 ,10.89577, 125.31412, 80.89577)";

        //声明Query查询对象
        Query query = new Query("string-data", ECQL.toFilter(bbox));

        Filter filter = ECQL.toFilter(bbox);

        //构建mysql数据库连接数据源--DataSource
        Map<String, Object> mapParams = new HashMap<String, Object>();
        mapParams.put(DBCPDataSourceFactory.DSTYPE.key, "DBCP");
        mapParams.put(DBCPDataSourceFactory.DRIVERCLASS.key, "com.mysql.cj.jdbc.Driver");
        mapParams.put(DBCPDataSourceFactory.JDBC_URL.key, "jdbc:mysql://172.16.67.23:7306/geo?useUnicode=true&characterEncoding=UTF-8&autoReconnect=true&useSSL=false&zeroDateTimeBehavior=convertToNull&serverTimezone=Asia/Shanghai");
        mapParams.put(DBCPDataSourceFactory.USERNAME.key, "root");
        mapParams.put(DBCPDataSourceFactory.PASSWORD.key, "Ucsp123#");
        mapParams.put(DBCPDataSourceFactory.MAXACTIVE.key, Integer.valueOf(10));
        mapParams.put(DBCPDataSourceFactory.MAXIDLE.key, Integer.valueOf(0));

        DataSource source = DataSourceFinder.getDataSource(mapParams);

        DataStore dataStore = DataStoreFinder.getDataStore(mapParams);


        System.out.println("111111111111");

    }
}



