package cn.com.taiji.cql.test;

import cn.com.taiji.common.model.EsDataSource;
import org.apache.commons.lang3.StringUtils;
import org.apache.http.HttpHost;
import org.apache.http.auth.AuthScope;
import org.apache.http.auth.UsernamePasswordCredentials;
import org.apache.http.client.CredentialsProvider;
import org.apache.http.impl.client.BasicCredentialsProvider;
import org.elasticsearch.client.RestClient;
import org.geotools.api.data.DataStore;
import org.geotools.data.elasticsearch.ElasticDataStore;
import org.geotools.data.elasticsearch.ElasticDataStoreFactory;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

public class TestEs {

    public static void main(String[] args) throws Exception{


        EsDataSource esDataSource = new EsDataSource();
        esDataSource.setUris("172.16.67.39:9211,172.16.67.40:9211,172.16.67.41:9211");
        esDataSource.setUsername("elastic");
        esDataSource.setPassword("Ucsp*20220922*");
        esDataSource.setConnectionTimeout(5000);
        esDataSource.setMaxConnection(100);
        esDataSource.setConnectionRequestTimeout(30000);
        esDataSource.setSocketTimeout(30000);
        esDataSource.setMaxIdle(2);
        esDataSource.setMaxTotal(3);
        esDataSource.setMinIdle(1);

        RestClient restClient = createRestClient(esDataSource);

        DataStore dataStore = new ElasticDataStore(restClient, "hnwt_common_use_es");
        String[] typeNames = dataStore.getTypeNames();

        System.out.println(typeNames.length);



    }

    public static RestClient createRestClient(EsDataSource esDataSource) throws Exception {

        String[] esUris=esDataSource.getUris().split(",");

        HttpHost[] httpHosts = new HttpHost[esUris.length];
        //将地址转换为http主机数组，未配置端口则采用默认9200端口，配置了端口则用配置的端口
        for (int i = 0; i < httpHosts.length; i++) {
            if (!StringUtils.isEmpty(esUris[i])) {
                if (esUris[i].contains(":")) {
                    String[] uris = esUris[i].split(":");
                    httpHosts[i] = new HttpHost(uris[0], Integer.parseInt(uris[1]), "http");
                } else {
                    httpHosts[i] = new HttpHost(esUris[i], 9200, "http");
                }
            }
        }

        final CredentialsProvider credentialsProvider = new BasicCredentialsProvider();
        credentialsProvider.setCredentials(AuthScope.ANY, new UsernamePasswordCredentials(esDataSource.getUsername(), esDataSource.getPassword()));

        return RestClient.builder(httpHosts)
                .setRequestConfigCallback(
                        requestConfigBuilder -> {
                            requestConfigBuilder.setConnectTimeout(esDataSource.getConnectionTimeout());
                            requestConfigBuilder.setSocketTimeout(esDataSource.getSocketTimeout());
                            requestConfigBuilder.setConnectionRequestTimeout(esDataSource.getConnectionRequestTimeout());
                            return requestConfigBuilder;
                        }
                ).setHttpClientConfigCallback(
                        httpAsyncClientBuilder -> httpAsyncClientBuilder.setDefaultCredentialsProvider(credentialsProvider).setMaxConnTotal(30).setMaxConnPerRoute(30)
                ).build();

    }
}
