package cn.com.taiji.common.domain;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;

/**
 * 扩展分页信息
 * @param <T>
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class PageResult<T> implements Serializable {

    private static final long serialVersionUID = -275582248840137389L;

    /**
     *当前页数
     */
    private Long pageNumber;
    /**
     *一页显示多少条记录
     */
    private Long pageSize;

    /**
     * 总页数
     */
    private Long pageCount;


     /**
      * 总记录数
      */
    private Long recordCount=0l;

    /**
     * 是否成功：0 成功、1 成功，但记录为空、-1 失败
     */
    private Integer resp_code;


    /**
     * 响应码描述信息
     */
    private String resp_msg;

    /**
     * 当前页结果集
     */
    private T datas;
}
