package cn.com.taiji.common.model;

import lombok.Data;

import java.io.Serializable;

/**
 * @author zzyx 2024/1/5
 */
@Data
public class LayerStyleView implements Serializable {


    /**
     * 图层代码
     */
    private String layerCode;

    /**
     * 样式id
     *
     */
    private String styleId;
    /**
     * 1:点，2:线，3:面
     *
     */

    private Integer type;

    /**
     * 宽度
     *
     */
    private Integer width =1;

    /**
     * 高度
     *
     */
    private Integer height =1;

    /**
     * 点线面颜色 颜色支持rgb rgba 如(255,0,255) ||(255, 0, 0, 128)
     *
     */
    private String color;

    /**
     *
     * 是否填充或者只显示边框
     */

    private Integer isFill;

    /**
     *
     * 边框颜色
     */
    private String borderColor;

    /**
     *
     * 边框大小
     */
    private Integer borderSize=1;

    /**
     * 边框为虚线还是实现
     */
    private Integer isDashed;

    /**
     * 虚线间隔 5像素实线，5像素空白  float[] dashPattern = {100, 10};
     *
     */
    private String dashPattern;
    /**
     *
     * 背景图片样式 面背景图片(使用images中的图片)
     */

    private String bgImage;

    /**
     * 是否显示中心点名称
     *
     */

    private Integer isShowName;

    /**
     *
     * 字体颜色
     */
    private String fontColor;

    /**
     * 字体大小
     */
    private Integer fontSize=1;

    /**
     * 中心点图片
     */
    private String centerPointImg;

    /**
     * 点大小
     */

    private Integer pointSize;

    /**
     * 点形状(1:正方形,2:三角形,3:圆形)
     */

    private Integer pointType;

    /**
     * 面中心点图片
     */
    private String centerPointImage;

    /**
     * 点标记图片
     */
    private String pointMarkerImage;
    /**
     * 点图片宽度
     */
    private Integer pointMarkerImageWidth=13;

    /**
     * 点图片高度
     */
    private Integer pointMarkerImageHeight=13;
}

