
package cn.com.taiji.tile.model;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;
import java.util.Map;

@JsonIgnoreProperties(
        ignoreUnknown = true
)
@Data
@NoArgsConstructor
@AllArgsConstructor
public class AggsResult {
    @JsonProperty("centroid")
    private Centroid centroid;
    @JsonProperty("large-grid")
    private LargeGrid largeGrid;
    @JsonProperty("total")
    private Total total;
    private Map<String, Object> group;
    private String count;
    private String lat;
    private String lon;

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public static class Buckets {
        @JsonProperty("key")
        private String key;
        @JsonProperty("doc_count")
        private long docCount;
    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public static class LargeGrid {
        @JsonProperty("buckets")
        private List<Buckets> buckets;
    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public static class Total {
        @JsonProperty("doc_count")
        private long total;
    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public static class CentroidLocation {
        @JsonProperty("lat")
        private String lat;
        @JsonProperty("lon")
        private String lon;
    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public static class Centroid {
        @JsonProperty("count")
        private String count;
        @JsonProperty("location")
        private CentroidLocation location;
    }
}
