package cn.com.taiji.tile.util;

import cn.com.taiji.tile.model.POI;
import org.apache.commons.lang3.StringUtils;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.List;


public class HotImageTile {

    public byte[] setHotImage(List<POI> poiList, String bboxStr) {
        double[] matrix = new double[65536];
        double[] bbox = new double[4];
        if (StringUtils.isNotBlank(bboxStr)) {
            String[] split = bboxStr.split(",");
            for (int i = 0; i < split.length; i++) {
                bbox[i] = Double.parseDouble(split[i]);
            }
        }
        for (POI poi : poiList) {
            int[] pxy = TileUtils.toPixelXY(poi.getLon(), poi.getLat(), bbox[0], bbox[1], bbox[2], bbox[3]);
            HotImageTileUtils.press(matrix, pxy[0], pxy[1], 1);
        }
        double presure = 0.0D;
        BufferedImage image = new BufferedImage(256, 256, 2);
        for (int x = 0; x < 256; x++) {
            for (int y = 0; y < 256; y++) {
                presure = matrix[x * 256 + y];
                if (presure > 0.0D) {
                    image.setRGB(x, y, HotImageTileUtils.toRGB(presure).getRGB());
                }
            }
        }
        ByteArrayOutputStream buffer = new ByteArrayOutputStream();
        try {
            ImageIO.write(image, "png", buffer);
        } catch (IOException e) {
            e.printStackTrace();
        }
        return buffer.toByteArray();
    }
}