 package cn.com.taiji.tile.util;
 
 public class RGBTable {
   final int distance;
   final int d2;
   double[] table;
   
   public RGBTable(int distance) {
    this.distance = distance;
  this.d2 = this.distance * this.distance;
     this.table = new double[(2 * distance + 1) * (2 * distance + 1)];
     initPressureTable();
   }
   
   private void initPressureTable() {
     for (int dx = -this.distance; dx <= this.distance; dx++) {
       for (int dy = -this.distance; dy <= this.distance; dy++) {
         this.table[toIndex(dx, dy)] = pressure(dx, dy);
       }
     } 
   }
 
   
   public double getPressure(int dx, int dy) {
     if (-this.distance <= dx && dx <= this.distance && -this.distance <= dy && dy <= this.distance) {
       if (dx * dx + dy * dy <= this.d2){
         return this.table[toIndex(dx, dy)];
       }
       return 0.0D;
     } 
     return 0.0D;
   }
   
   private int toIndex(int dx, int dy) {
    return (dx + this.distance) * (2 * this.distance + 1) + dy + this.distance;
   }
   
   private double pressure(double dx, double dy) {
     double dis = Math.sqrt(dx * dx + dy * dy);
     return 1.0D / (dis + 1.0D);
   }
 }
