package cn.com.taiji.web.controller;

import cn.com.taiji.common.domain.PageResult;
import cn.com.taiji.common.domain.Result;
import cn.com.taiji.cql.service.IECqlService;
import cn.com.taiji.web.service.IEnterpriseService;
import cn.com.taiji.web.vo.DeviceVo;
import cn.com.taiji.web.vo.EnterpriseVo;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;


/**
 *企业一张图通用查询控制器
 *
 * @author makejava
 * @since 2021-04-22 16:53:35
 */
@Slf4j
@RestController
public class EnterpriseController {


    @Autowired
    private IEnterpriseService enterpriseService;


    /**
     *企业列表查询接口
     * @param enterpriseVo
     */
    @PostMapping("/enterpriseQuery")
    public PageResult enterpriseQuery(@RequestBody EnterpriseVo enterpriseVo) throws Exception {

        return enterpriseService.enterpriseQuery(enterpriseVo);
    }


    /**
     * 根据圆心和半径查找周边企业设备
     * @param deviceVo
     * @return
     * @throws Exception
     */

    @PostMapping("/deviceQuery")
    public Result deviceQuery(@RequestBody DeviceVo deviceVo) throws Exception {

        return enterpriseService.deviceQuery(deviceVo);
    }

    /**
     * 企业数量统计
     * @return
     * @throws Exception
     */

    @PostMapping("/staticsQuery")
    public Result staticsQuery() throws Exception {

        return enterpriseService.staticsQuery();
    }



}
