package cn.com.taiji.web.controller;

import cn.com.taiji.common.domain.PageResult;
import cn.com.taiji.common.domain.Result;
import cn.com.taiji.web.service.IEnterpriseService;
import cn.com.taiji.web.service.IGeoDataSourceService;
import cn.com.taiji.web.vo.DeviceVo;
import cn.com.taiji.web.vo.EnterpriseVo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;


/**
 *数据源控制器
 *
 * @author makejava
 * @since 2021-04-22 16:53:35
 */
@Slf4j
@RestController
public class GeoDataSourceController {


    @Autowired
    private IGeoDataSourceService geoDataSourceService;


    /**
     *数据源列表查询接口
     * @param paramMaps
     */
    @PostMapping("/geoDsQuery")
    public PageResult geoDsQuery(@RequestBody Map<String,Object> paramMaps) throws Exception {

        List<Map<String, Object>> dataList = new ArrayList<Map<String, Object>>();


        int respCode = 0;

        String respMsg = "操作成功";

        if(paramMaps.containsKey("cql")){

            String cql = paramMaps.get("cql").toString();

            if(cql !=null && !"".equals(cql)){

                return geoDataSourceService.geoDsQuery(paramMaps);

            }else{

                respCode = 2;

                respMsg = "数据源列表查询的过滤条件cql参数为空或者为null!";

            }

        }else{

            respCode = 2;

            respMsg = "数据源列表查询的过滤条件cql参数不存在!";

        }



        return PageResult.<List<Map<String, Object>>>builder().datas(dataList).resp_code(respCode).resp_msg(respMsg).build();
    }


    /**
     * 数据源增加接口
     * @param paramMaps
     * @return
     * @throws Exception
     */

    @PostMapping("/geoDsAddInfo")
    public Result geoDsAddInfo(@RequestBody Map<String,Object> paramMaps) throws Exception {

        return geoDataSourceService.geoDsAddInfo(paramMaps);
    }

    /**
     * 数据源修改接口
     * @param paramMaps
     * @return
     * @throws Exception
     */

    @PostMapping("/geoDsUpdateInfo")
    public Result geoDsUpdateInfo(@RequestBody Map<String,Object> paramMaps) throws Exception {


        int respCode = 0;

        String respMsg = "操作成功";

        if(paramMaps !=null && paramMaps.keySet().size() >1 && paramMaps.containsKey("cql")){

            String cql = paramMaps.get("cql").toString();

            if(cql !=null && !"".equals(cql)){

                return geoDataSourceService.geoDsUpdateInfo(paramMaps);

            }else{

                respCode = 2;

                respMsg = "数据源修改条件cql参数为空或者为null!";

            }

        }else{

            respCode = 2;

            respMsg = "数据源修改条件cql参数不存在或者数据源修改属性不存在！";

        }

        return Result.of(null,respCode,respMsg);
    }

    /**
     * 数据源删除接口
     * @param paramMaps
     * @return
     * @throws Exception
     */

    @PostMapping("/geoDsRemoveInfo")
    public Result geoDsRemoveInfo(@RequestBody Map<String,Object> paramMaps) throws Exception {

        int respCode = 0;

        String respMsg = "操作成功";

        if(paramMaps !=null && paramMaps.keySet().size() >0 && paramMaps.containsKey("cql")){

            String cql = paramMaps.get("cql").toString();

            if(cql !=null && !"".equals(cql)){

                return geoDataSourceService.geoDsRemoveInfo(paramMaps);

            }else{

                respCode = 2;

                respMsg = "数据源删除条件cql参数为空或者为null!";

            }

        }else{

            respCode = 2;

            respMsg = "数据源删除条件cql参数不存在！";

        }

        return Result.of(null,respCode,respMsg);
    }



}
