package cn.com.taiji.web.model;

import lombok.Data;

import java.io.Serializable;

@Data
public class DeviceInfo implements Serializable {

    /**
     * 主键
     */
    private int id;

    /**
     * 数据主键
     */
    private String dataId;

    /**
     * 监控资源唯一标识
     */
    private String pn;

    /**
     * 协转号
     */
    private String groupid;

    /**
     * 监控号
     */
    private String monitorid;

    /**
     * 设备/区域/系统名称（必选）
     */
    private String name;

    /**
     * 设备的在线状态，1代表在线，0代表离线，国标状态同步是必用
     */
    private String online;

    /**
     * 是否有录像
     */
    private String savestatus;

    /**
     * 标识摄像机类型：1-球机；2-半球；3-固定枪机；4-遥控枪机。当目录项为摄像机时可选。
     */
    private String ptztype;

    /**
     * 设备ID
     */
    private String deviceid;

    /**
     * 对应组织机构里面的areacode用于统计和展示
     */
    private String areacode;

    /**
     * 经度(可选)
     */
    private String longitude;

    /**
     * 纬度(可选)
     */
    private String latitude;

    /**
     * 是否故障（0没有故障 1有故障）
     */
    private String faultedflag;

    /**
     * 设备可用状态，ON代表启用，OFF代表关闭（必选）
     */
    private String status;

    /**
     * 是否是前端摄像头，用于列表展示,1代表是，0代表其它
     */
    private String isfront;

    /**
     * 视频点位分类
     */
    private String type;

    /**
     * 视频点位分类字典值
     */
    private String typeValue;

    /**
     * 行政规划中心编码
     */
    private String civilcode;

    /**
     * 距离
     */
    private Double distance;
}
