package cn.com.taiji.web.service;

import cn.com.taiji.common.domain.PageResult;
import cn.com.taiji.common.domain.Result;
import cn.com.taiji.common.model.LayerGroupDsView;
import cn.com.taiji.common.model.LayerStyleView;

import javax.sql.DataSource;
import java.util.List;
import java.util.Map;

public interface IGeoDataSourceService {

    /**
     * 获取图层代码对应的数据源信息
     * @return
     */
    List<LayerGroupDsView> layerCodeGeoDataSource(List<String> layerCodeList) throws Exception;

    /**
     * 获取图层代码对应的样式信息
     * @return
     */
    Map<String,List<LayerStyleView>> layerCodeShapeStyle(List<String> layerCodeList) throws Exception;

    DataSource defaultDataSource() throws Exception;

    /**
     * 数据源列表查询接口
     * @param paramMaps
     * @return
     */

    PageResult geoDsQuery(Map<String,Object> paramMaps) throws Exception;

    /**
     * 数据源增加接口
     * @param paramMaps
     * @return
     * @throws Exception
     */

    Result geoDsAddInfo(Map<String,Object> paramMaps) throws Exception;

    /**
     * 数据源修改接口
     * @param paramMaps
     * @return
     * @throws Exception
     */

    Result geoDsUpdateInfo(Map<String,Object> paramMaps) throws Exception;

    /**
     * 数据源删除接口
     * @param paramMaps
     * @return
     * @throws Exception
     */

    Result geoDsRemoveInfo(Map<String,Object> paramMaps) throws Exception;
}
